import React, { RefObject, SyntheticEvent } from 'react';
import { DefaultLoadingProps } from './DefaultLoading';
import { DeafultLoadMoreProps } from './DefaultLoadMore';
export interface LazyListProps<T> {
    hasNextPage: boolean;
    loading: boolean;
    isLoaded?: (index: number) => boolean;
    items?: T[];
    loadNextPage: (e: SyntheticEvent) => void;
    registerScrollableList?: (ref: RefObject<HTMLElement>) => void;
    renderRoot?: React.FC;
    renderRow: (data: T, index: number) => JSX.Element;
    renderLoading?: React.FC<DefaultLoadingProps>;
    renderLoadMore?: React.FC<DeafultLoadMoreProps>;
    renderLoadingIndicator?: React.FC;
    renderOutsideLoading?: React.FC;
    threshold?: number;
    withPrefetchedData?: boolean;
    shouldConfirmInfiniteLoading?: boolean;
}
export declare const LazyList: <T extends object>({ hasNextPage, loading, items, loadNextPage, threshold, withPrefetchedData, registerScrollableList, renderRoot: Root, renderRow, renderLoading: Loading, renderLoadMore: LoadMore, shouldConfirmInfiniteLoading, }: LazyListProps<T>) => JSX.Element;
