import styled from 'styled-components';
import { searchInputWidth } from '../Input';
export var SuggestionSearchContainer = styled.div.withConfig({ displayName: "SuggestionSearchContainer", componentId: "sc-5giblp" })(function (_a) {
    var fluid = _a.fluid;
    return ({
        position: 'relative',
        width: fluid ? '100%' : 'unset',
    });
});
export var DropdownWrapper = styled.div.withConfig({ displayName: "DropdownWrapper", componentId: "sc-u6vhtu" })(function (_a) {
    var theme = _a.theme, itemsLength = _a.itemsLength, fluid = _a.fluid, _b = _a.height, height = _b === void 0 ? 192 : _b;
    return ({
        position: 'absolute',
        width: searchInputWidth(fluid),
        height: itemsLength <= 3 ? 'unset' : height,
        minHeight: 64,
        overflow: 'hidden',
        border: "1px solid " + theme.greyscale.dark,
        borderTop: 'none',
        borderBottomLeftRadius: 17,
        borderBottomRightRadius: 17,
        background: '#ffffff',
        boxShadow: '0 3px 6px rgba(0, 0, 0, 0.16)',
        zIndex: 1,
    });
});
export var DropdownContainer = styled.div.withConfig({ displayName: "DropdownContainer", componentId: "sc-d3eywm" })(function (_a) {
    var itemsLength = _a.itemsLength;
    return ({
        height: '100%',
        minHeight: 'inherit',
        overflow: 'auto',
        display: itemsLength === 0 ? 'flex' : 'inherit',
        flexDirection: 'column',
        justifyContent: 'center',
        alignItems: 'center',
    });
});
